- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# TutorialCpp_NLP Class Reference

`#include <TutorialCpp_nlp.hpp>`

Inheritance diagram for TutorialCpp_NLP:

[legend]
Collaboration diagram for TutorialCpp_NLP:

[legend]
List of all members.

## Public Member Functions
| TutorialCpp_NLP (Index N, const Number *a)
| constructor that takes in problem data
virtual | ~TutorialCpp_NLP ()
| default destructor
| TutorialCpp_NLP (Index N, const Number *a)
| constructor that takes in problem data
virtual | ~TutorialCpp_NLP ()
| default destructor
| TutorialCpp_NLP (Index N, const Number *a)
| constructor that takes in problem data
virtual | ~TutorialCpp_NLP ()
| default destructor
Overloaded from TNLP
virtual bool | get_nlp_info (Index &n, Index &m, Index &nnz_jac_g, Index &nnz_h_lag, IndexStyleEnum &index_style)
| Method to return some info about the nlp.
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| Method to return the bounds for my problem.
virtual bool | get_starting_point (Index n, bool init_x, Number *x, bool init_z, Number *z_L, Number *z_U, Index m, bool init_lambda, Number *lambda)
| Method to return the starting point for the algorithm.
virtual bool | eval_f (Index n, const Number *x, bool new_x, Number &obj_value)
| Method to return the objective value.
virtual bool | eval_grad_f (Index n, const Number *x, bool new_x, Number *grad_f)
| Method to return the gradient of the objective.
virtual bool | eval_g (Index n, const Number *x, bool new_x, Index m, Number *g)
| Method to return the constraint residuals.
virtual bool | eval_jac_g (Index n, const Number *x, bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).
virtual bool | eval_h (Index n, const Number *x, bool new_x, Number obj_factor, Index m, const Number *lambda, bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).
Solution Methods
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_value, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called when the algorithm is complete so the TNLP can store/write the solution.
Overloaded from TNLP
virtual bool | get_nlp_info (Index &n, Index &m, Index &nnz_jac_g, Index &nnz_h_lag, IndexStyleEnum &index_style)
| Method to return some info about the nlp.
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| Method to return the bounds for my problem.
virtual bool | get_starting_point (Index n, bool init_x, Number *x, bool init_z, Number *z_L, Number *z_U, Index m, bool init_lambda, Number *lambda)
| Method to return the starting point for the algorithm.
virtual bool | eval_f (Index n, const Number *x, bool new_x, Number &obj_value)
| Method to return the objective value.
virtual bool | eval_grad_f (Index n, const Number *x, bool new_x, Number *grad_f)
| Method to return the gradient of the objective.
virtual bool | eval_g (Index n, const Number *x, bool new_x, Index m, Number *g)
| Method to return the constraint residuals.
virtual bool | eval_jac_g (Index n, const Number *x, bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).
virtual bool | eval_h (Index n, const Number *x, bool new_x, Number obj_factor, Index m, const Number *lambda, bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).
Solution Methods
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_value, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called when the algorithm is complete so the TNLP can store/write the solution.
Overloaded from TNLP
virtual bool | get_nlp_info (Index &n, Index &m, Index &nnz_jac_g, Index &nnz_h_lag, IndexStyleEnum &index_style)
| Method to return some info about the nlp.
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| Method to return the bounds for my problem.
virtual bool | get_starting_point (Index n, bool init_x, Number *x, bool init_z, Number *z_L, Number *z_U, Index m, bool init_lambda, Number *lambda)
| Method to return the starting point for the algorithm.
virtual bool | eval_f (Index n, const Number *x, bool new_x, Number &obj_value)
| Method to return the objective value.
virtual bool | eval_grad_f (Index n, const Number *x, bool new_x, Number *grad_f)
| Method to return the gradient of the objective.
virtual bool | eval_g (Index n, const Number *x, bool new_x, Index m, Number *g)
| Method to return the constraint residuals.
virtual bool | eval_jac_g (Index n, const Number *x, bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).
virtual bool | eval_h (Index n, const Number *x, bool new_x, Number obj_factor, Index m, const Number *lambda, bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).
Solution Methods
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_value, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called when the algorithm is complete so the TNLP can store/write the solution.
## Private Member Functions
Methods to block default compiler methods.
The compiler automatically generates the following three methods. Since the default compiler implementation is generally not what you want (for all but the most simple classes), we usually put the declarations of these methods in the private section and never implement them. This prevents the compiler from implementing an incorrect "default" behavior without us knowing. (See Scott Meyers book, "Effective C++")
| TutorialCpp_NLP ()
| TutorialCpp_NLP (const TutorialCpp_NLP &)
TutorialCpp_NLP & | operator= (const TutorialCpp_NLP &)
Methods to block default compiler methods.
The compiler automatically generates the following three methods. Since the default compiler implementation is generally not what you want (for all but the most simple classes), we usually put the declarations of these methods in the private section and never implement them. This prevents the compiler from implementing an incorrect "default" behavior without us knowing. (See Scott Meyers book, "Effective C++")
| TutorialCpp_NLP ()
| TutorialCpp_NLP (const TutorialCpp_NLP &)
TutorialCpp_NLP & | operator= (const TutorialCpp_NLP &)
Methods to block default compiler methods.
The compiler automatically generates the following three methods. Since the default compiler implementation is generally not what you want (for all but the most simple classes), we usually put the declarations of these methods in the private section and never implement them. This prevents the compiler from implementing an incorrect "default" behavior without us knowing. (See Scott Meyers book, "Effective C++")
| TutorialCpp_NLP ()
| TutorialCpp_NLP (const TutorialCpp_NLP &)
TutorialCpp_NLP & | operator= (const TutorialCpp_NLP &)
## Private Attributes
NLP data
Index | N_
| Number of variables.
Number * | a_
| Value of constants in constraints.
NLP data
Number * | a_
| Value of constants in constraints.
NLP data
Number * | a_
| Value of constants in constraints.

## Detailed Description

Definition at line 34 of file TutorialCpp_nlp.hpp.

## Constructor & Destructor Documentation

TutorialCpp_NLP::TutorialCpp_NLP | ( | Index | N,
|  | const Number * | a |
| ) |  |  |

constructor that takes in problem data

virtual TutorialCpp_NLP::~TutorialCpp_NLP | ( |  | ) | `[virtual]`

default destructor

TutorialCpp_NLP::TutorialCpp_NLP | ( |  | ) | `[private]`

TutorialCpp_NLP::TutorialCpp_NLP | ( | const TutorialCpp_NLP & |  | ) | `[private]`

TutorialCpp_NLP::TutorialCpp_NLP | ( | Index | N,
|  | const Number * | a |
| ) |  |  |

constructor that takes in problem data

virtual TutorialCpp_NLP::~TutorialCpp_NLP | ( |  | ) | `[virtual]`

default destructor

TutorialCpp_NLP::TutorialCpp_NLP | ( |  | ) | `[private]`

TutorialCpp_NLP::TutorialCpp_NLP | ( | const TutorialCpp_NLP & |  | ) | `[private]`

TutorialCpp_NLP::TutorialCpp_NLP | ( | Index | N,
|  | const Number * | a |
| ) |  |  |

constructor that takes in problem data

virtual TutorialCpp_NLP::~TutorialCpp_NLP | ( |  | ) | `[virtual]`

default destructor

TutorialCpp_NLP::TutorialCpp_NLP | ( |  | ) | `[private]`

TutorialCpp_NLP::TutorialCpp_NLP | ( | const TutorialCpp_NLP & |  | ) | `[private]`

## Member Function Documentation

virtual bool TutorialCpp_NLP::get_nlp_info | ( | Index & | n,
|  | Index & | m,
|  | Index & | nnz_jac_g,
|  | Index & | nnz_h_lag,
|  | IndexStyleEnum & | index_style |
| ) |  |  | `[virtual]`

Method to return some info about the nlp.

virtual bool TutorialCpp_NLP::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u |
| ) |  |  | `[virtual]`

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::get_starting_point | ( | Index | n,
|  | bool | init_x,
|  | Number * | x,
|  | bool | init_z,
|  | Number * | z_L,
|  | Number * | z_U,
|  | Index | m,
|  | bool | init_lambda,
|  | Number * | lambda |
| ) |  |  | `[virtual]`

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number & | obj_value |
| ) |  |  | `[virtual]`

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_grad_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number * | grad_f |
| ) |  |  | `[virtual]`

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Number * | g |
| ) |  |  | `[virtual]`

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_jac_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Index | nele_jac,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_h | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number | obj_factor,
|  | Index | m,
|  | const Number * | lambda,
|  | bool | new_lambda,
|  | Index | nele_hess,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).

Reimplemented from Ipopt::TNLP.

virtual void TutorialCpp_NLP::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_value,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

This method is called when the algorithm is complete so the TNLP can store/write the solution.

TutorialCpp_NLP& TutorialCpp_NLP::operator= | ( | const TutorialCpp_NLP & |  | ) | `[private]`

virtual bool TutorialCpp_NLP::get_nlp_info | ( | Index & | n,
|  | Index & | m,
|  | Index & | nnz_jac_g,
|  | Index & | nnz_h_lag,
|  | IndexStyleEnum & | index_style |
| ) |  |  | `[virtual]`

Method to return some info about the nlp.

virtual bool TutorialCpp_NLP::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u |
| ) |  |  | `[virtual]`

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::get_starting_point | ( | Index | n,
|  | bool | init_x,
|  | Number * | x,
|  | bool | init_z,
|  | Number * | z_L,
|  | Number * | z_U,
|  | Index | m,
|  | bool | init_lambda,
|  | Number * | lambda |
| ) |  |  | `[virtual]`

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number & | obj_value |
| ) |  |  | `[virtual]`

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_grad_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number * | grad_f |
| ) |  |  | `[virtual]`

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Number * | g |
| ) |  |  | `[virtual]`

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_jac_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Index | nele_jac,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_h | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number | obj_factor,
|  | Index | m,
|  | const Number * | lambda,
|  | bool | new_lambda,
|  | Index | nele_hess,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).

Reimplemented from Ipopt::TNLP.

virtual void TutorialCpp_NLP::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_value,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

This method is called when the algorithm is complete so the TNLP can store/write the solution.

TutorialCpp_NLP& TutorialCpp_NLP::operator= | ( | const TutorialCpp_NLP & |  | ) | `[private]`

virtual bool TutorialCpp_NLP::get_nlp_info | ( | Index & | n,
|  | Index & | m,
|  | Index & | nnz_jac_g,
|  | Index & | nnz_h_lag,
|  | IndexStyleEnum & | index_style |
| ) |  |  | `[virtual]`

Method to return some info about the nlp.

virtual bool TutorialCpp_NLP::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u |
| ) |  |  | `[virtual]`

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::get_starting_point | ( | Index | n,
|  | bool | init_x,
|  | Number * | x,
|  | bool | init_z,
|  | Number * | z_L,
|  | Number * | z_U,
|  | Index | m,
|  | bool | init_lambda,
|  | Number * | lambda |
| ) |  |  | `[virtual]`

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number & | obj_value |
| ) |  |  | `[virtual]`

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_grad_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number * | grad_f |
| ) |  |  | `[virtual]`

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Number * | g |
| ) |  |  | `[virtual]`

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_jac_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Index | nele_jac,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).

Implements Ipopt::TNLP.

virtual bool TutorialCpp_NLP::eval_h | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number | obj_factor,
|  | Index | m,
|  | const Number * | lambda,
|  | bool | new_lambda,
|  | Index | nele_hess,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).

Reimplemented from Ipopt::TNLP.

virtual void TutorialCpp_NLP::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_value,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

This method is called when the algorithm is complete so the TNLP can store/write the solution.

TutorialCpp_NLP& TutorialCpp_NLP::operator= | ( | const TutorialCpp_NLP & |  | ) | `[private]`

## Member Data Documentation

Index TutorialCpp_NLP::N_`[private]`

Number of variables.

Definition at line 118 of file TutorialCpp_nlp.hpp.

Number* TutorialCpp_NLP::a_`[private]`

Value of constants in constraints.

Definition at line 120 of file TutorialCpp_nlp.hpp.

Number* TutorialCpp_NLP::a_`[private]`

Value of constants in constraints.

Definition at line 120 of file TutorialCpp_nlp.hpp.

Number* TutorialCpp_NLP::a_`[private]`

Value of constants in constraints.

Definition at line 120 of file TutorialCpp_nlp.hpp.

The documentation for this class was generated from the following files:

- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/tutorial/CodingExercise/Cpp/1-skeleton/TutorialCpp_nlp.hpp
- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/tutorial/CodingExercise/Cpp/2-mistake/TutorialCpp_nlp.hpp
- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/tutorial/CodingExercise/Cpp/3-solution/TutorialCpp_nlp.hpp